#include <iostream>

#include <stdlib.h> 
#include <string.h> 
#include <stdio.h> 
#include <math.h> 








#pragma once


#define WAVE_FORMAT_UNKNOWN      0X0000;
#define WAVE_FORMAT_PCM          0X0001;
#define WAVE_FORMAT_MS_ADPCM     0X0002;
#define WAVE_FORMAT_IEEE_FLOAT   0X0003;
#define WAVE_FORMAT_ALAW         0X0006;
#define WAVE_FORMAT_MULAW        0X0007;
#define WAVE_FORMAT_IMA_ADPCM    0X0011;
#define WAVE_FORMAT_YAMAHA_ADPCM 0X0016;
#define WAVE_FORMAT_GSM          0X0031;
#define WAVE_FORMAT_ITU_ADPCM    0X0040;
#define WAVE_FORMAT_MPEG         0X0050;
#define WAVE_FORMAT_EXTENSIBLE   0XFFFE;



typedef struct
{
	unsigned char ChunkID[4];    // Contains the letters "RIFF" in ASCII form
	unsigned int ChunkSize;      // This is the size of the rest of the chunk following this number
	unsigned char Format[4];     // Contains the letters "WAVE" in ASCII form
} RIFF;

//-------------------------------------------
// [Channel]
// - streo     : [left][right]
// - 3 channel : [left][right][center]
// - quad      : [front left][front right][rear left][reat right]
// - 4 channel : [left][center][right][surround]
// - 6 channel : [left center][left][center][right center][right][surround]
//-------------------------------------------
typedef struct
{
	unsigned char  ChunkID[4];    // Contains the letters "fmt " in ASCII form
	unsigned int   ChunkSize;     // 16 for PCM.  This is the size of the rest of the Subchunk which follows this number.
	unsigned short AudioFormat;   // PCM = 1
	unsigned short NumChannels;   // Mono = 1, Stereo = 2, etc.
	unsigned int   SampleRate;    // 8000, 44100, etc.
	unsigned int   AvgByteRate;   // SampleRate * NumChannels * BitsPerSample/8
	unsigned short BlockAlign;    // NumChannels * BitsPerSample/8
	unsigned short BitPerSample;  // 8 bits = 8, 16 bits = 16, etc
} FMT;


typedef struct
{
	char          ChunkID[4];    // Contains the letters "data" in ASCII form
	unsigned int  ChunkSize;     // NumSamples * NumChannels * BitsPerSample/8
} DATA;


typedef struct
{
	RIFF Riff;
	FMT	 Fmt;
	DATA Data;
} WAVE_HEADER;




#define DURATION 10
#define SAMPLE_RATE 44100
#define CHANNEL 1
#define BIT_RATE 32

int xmain() {
	FILE * f_out;
    f_out = fopen("C:\\APM_Setup\\htdocs\\test2.wav", "wb");

    WAVE_HEADER header;
    memcpy(header.Riff.ChunkID, "RIFF", 4);
    header.Riff.ChunkSize = DURATION * SAMPLE_RATE * CHANNEL * BIT_RATE / 8 + 36;
    memcpy(header.Riff.Format, "WAVE", 4);

    memcpy(header.Fmt.ChunkID, "fmt ", 4);
    header.Fmt.ChunkSize = 0x10;
    header.Fmt.AudioFormat = WAVE_FORMAT_PCM;
    header.Fmt.NumChannels = CHANNEL;
    header.Fmt.SampleRate = SAMPLE_RATE;
    header.Fmt.AvgByteRate = SAMPLE_RATE * CHANNEL * BIT_RATE / 8;
    header.Fmt.BlockAlign = CHANNEL * BIT_RATE / 8;
    header.Fmt.BitPerSample = BIT_RATE;

    memcpy(header.Data.ChunkID, "data", 4);
    header.Data.ChunkSize = DURATION * SAMPLE_RATE * CHANNEL * BIT_RATE / 8;

    fwrite(&header, sizeof(header), 1, f_out);

    short y[1];
    double freq = 1000;
    for(int i = 0; i < SAMPLE_RATE * DURATION * CHANNEL * BIT_RATE / 8; i++) {
        y[0] = (short)30000*sin(2 * 3.141592 * i * freq / SAMPLE_RATE); // ӽ ڸƮ  
        fwrite(&y[0], sizeof(short), 1, f_out);
    }

    fclose(f_out);

    

	return 0;
}







typedef unsigned short      uint16_t; 
typedef unsigned int        uint32_t; 
//typedef int                 int16_t;
typedef unsigned char       byte; 



#if 0
 MSDN   üε. ũ⵵ 뵵 ٸ. ??

WAVEFORMATEX structure
https://msdn.microsoft.com/en-us/library/windows/desktop/dd757713(v=vs.85).aspx

typedef struct {
  WORD  wFormatTag;
  WORD  nChannels;
  DWORD nSamplesPerSec;
  DWORD nAvgBytesPerSec;
  WORD  nBlockAlign;
  WORD  wBitsPerSample;
  WORD  cbSize;
} WAVEFORMATEX;
#endif




//http://alvinalexander.com/java/jwarehouse/android/core/java/android/speech/srec/WaveHeader.java.shtml
typedef struct 
{ 
    char     chunk_id[4];       //RIFF
    uint32_t chunk_size;        // ũ + 36 
    char     format[4];         //WAVE
    char     fmtchunk_id[4];    //fmt 
    uint32_t fmtchunk_size;     //16
    uint16_t audio_format;      //PCM
    uint16_t num_channels;      //1
    uint32_t sample_rate;       //SampleRate
    uint32_t byte_rate;         //avr Channels * SampleRate * BPS/8
    uint16_t block_align;       //Channels * BPS/8
    uint16_t bps;               //bps
    char     datachunk_id[4];   //data
 
    uint32_t datachunk_size;    // ũ
}WavHeader;  

int total_file_len = 0;

void wav_read(char * file_name, WavHeader * header, byte ** real_data) 
{ 
    FILE * fp; 
    int len; 
    fp = fopen(file_name, "rb"); 
    len = fread(header, 1, sizeof(WavHeader), fp); 
    total_file_len += len; 
 
    //----------------------------------------
    printf("------------------------------\n");
    printf("header->sample_rate    [%d]\n", header->sample_rate   );    //[44100]
    printf("header->num_channels   [%d]\n", header->num_channels  );    //[1]    
    printf("header->byte_rate      [%d]\n", header->byte_rate     );    //[88200]
    printf("header->bps            [%d]\n", header->bps           );    //[16]   
    //----------------------------------------
    
    (*real_data) = (byte *)malloc(header->datachunk_size); 
    len = fread(*real_data, 1, header->datachunk_size, fp);  
    total_file_len += len; 
    fclose(fp); 
} 

void wav_write(char * file_name, WavHeader * header, byte * real_data) 
{ 
    FILE * fp; 
//    header->byte_rate *= 2;
//    header->datachunk_size /= 2;

    //----------------------------------------
    printf("------------------------------\n");
    printf("header->sample_rate    [%d]\n", header->sample_rate   );    //[44100]
    printf("header->num_channels   [%d]\n", header->num_channels  );    //[1]    
    printf("header->byte_rate      [%d]\n", header->byte_rate     );    //[88200]
    printf("header->bps            [%d]\n", header->bps           );    //[16]   
    printf("header->datachunk_size [%d]\n", header->datachunk_size);    //


#if 0
http://crystalcube.co.kr/123

    char     chunk_id[4];       //RIFF
    uint32_t chunk_size;        // ũ + 36 
    char     format[4];         //WAVE
    char     fmtchunk_id[4];    //fmt 
    uint32_t fmtchunk_size;     //16
    uint16_t audio_format;      //PCM
    uint16_t num_channels;      //1
    uint32_t sample_rate;       //SampleRate
    uint32_t byte_rate;         //avr : Channels * SampleRate * BPS/8
    uint16_t block_align;       //Channels * BPS/8
    uint16_t bps;               //bps
    char     datachunk_id[4];   //data
 
    uint32_t datachunk_size;    // ũ
#endif


    //----------------------------------------
    //2  ϱ
    //WAV ̸  ϱ. 
    //int  ũ  ū .  ߻ϴ 
    //----------------------------------------
    int size = header->datachunk_size;
    header->datachunk_size  = header->datachunk_size / 2;
    header->chunk_size      = header->datachunk_size + 35;
    header->byte_rate       = header->num_channels * header->sample_rate * header->bps / 8.0;
    header->block_align     = header->num_channels * header->bps / 8.0;

    printf("header->datachunk_size [%d]\n", header->datachunk_size);    //

    fp = fopen(file_name, "wb"); 
    fwrite(header, sizeof(WavHeader), 1, fp); 
    byte *r = (byte *)malloc(size/2);
    for(int i = 0; i< size; i=i+1)
    {
       *(r+i/2) = *(real_data + i);  //̺κ!! 
    }
    printf("------------------------------\n");
    fwrite(r,size/2 , 1, fp); 
    free(r); 
    fclose(fp);    
} 


 
 

int main(int argc, char** argv) 
{
    WavHeader header; // 
    byte * real_data; //Ҹ 
    wav_read("C:\\APM_Setup\\htdocs\\test.wav", &header, &real_data); 
    wav_write("C:\\APM_Setup\\htdocs\\write.wav", &header, real_data); 
    free(real_data); 



//    xmain(); ׽Ʈ. ߾ȵ. 

	return 0;
}






